#pragma warning (disable: 4996)
#pragma warning (disable: 4819) 

#include "kutil.h"
#include <chrono>
FILE* logFile = NULL;

#define MAX_PATH_LENGTH 200
#define MAX_PRINTLINE_LENGTH 8000

using namespace std::chrono;

void initUserDir(char* userId) {
	char logFileDir[MAX_PATH_LENGTH];
	memset(logFileDir, 0, sizeof(logFileDir));
	sprintf(logFileDir, "%s", getenv("TEMP"));
	strcat(logFileDir, "\\tc_");
	strcat(logFileDir, userId);
	if (chdir(logFileDir) != ITK_ok) {
		printf(">> Create Path: %s\n", logFileDir);
		mkdir(logFileDir);
	}
}

int WriteToFile(FILE* file, const char* text)
{
	if (!file) {
		return ITK_ok;
	}
	va_list arg;
	//char tmp[MAX_PRINTLINE_LENGTH];
	char* time_str = getTime();
	//get the message
	//memset(tmp, 0, sizeof(tmp));
	//va_start(arg, format);
	//vsprintf(tmp, format, arg);
	//va_end(arg);
	//print message to log file
	//WriteLog(debug, "дݣ%s", tmp);
	fprintf(file, "[%s] - %s\r\n",time_str, text);
	fflush(file);
	free(time_str);
	return ITK_ok;
}

int getCurrentMilliSeconds() {
	unsigned __int64 now = std::chrono::duration_cast<std::chrono::milliseconds>(std::chrono::system_clock::now().time_since_epoch()).count();
	std::cout << now << std::endl;
	return now % 1000;
}

char* getTime() {
	time_t now;
	struct tm* p;
	char date_string[MAX_PATH_LENGTH];
	time(&now);
	//logFile = NULL;
	//current_time(&status_now);
	p = localtime(&now);
	memset(date_string, 0, sizeof(date_string));
	sprintf(date_string, "%4d-%02d-%02d %02d:%02d:%02d", 1900 + p->tm_year, p->tm_mon + 1, p->tm_mday, p->tm_hour, p->tm_min, p->tm_sec);
	char* dateC = (char*)malloc(sizeof(char) * (strlen(date_string)+1));
	strcpy(dateC, date_string);
	return dateC;
}

int CreateUserFile(logical debug, const char* FunctionName, char* userId, char** fullname, FILE** file)
{
	int ifail = ITK_ok;
	//date_t status_now;
	//char* date_string = NULL;
	char date_string[MAX_PATH_LENGTH];
	char logFileDir[MAX_PATH_LENGTH];
	char logFileName[MAX_PATH_LENGTH];
	//char* session_uid = NULL;
	//tag_t session_tag = NULLTAG;

	time_t now;
	struct tm* p;

	time(&now);

	//logFile = NULL;
	//current_time(&status_now);
	p = localtime(&now);

	memset(date_string, 0, sizeof(date_string));
	sprintf(date_string, "%4d%02d%02d", 1900 + p->tm_year, p->tm_mon + 1, p->tm_mday);
	//sprintf(date_string, "%4d%02d%02d", 1900 + p->tm_year, p->tm_mon + 1, p->tm_mday);
	//if( DATE_date_to_string( status_now, "%Y%m%d%H%M%S", &date_string) != ITK_ok )
	//ifail = ITK_date_to_string (status_now, &date_string );
	//if (ifail)
	//{
	//	printf("!*ERROR*!: Failed to get current date time\n");
	//	goto CLEANUP;
	//}

	memset(logFileDir, 0, sizeof(logFileDir));
	memset(logFileName, 0, sizeof(logFileName));
	//get log dir
	sprintf(logFileDir, "%s", getenv("TEMP"));
	strcat(logFileDir, "\\tc_");
	strcat(logFileDir, userId);
	//printf("\n log file dir: %s\n", logFileDir);
	//try to change dir to TC_USER_LOG_DIR
	if (chdir(logFileDir) != ITK_ok)
	{
		WriteLog(debug, "ûļʧܣ%s", logFileDir);
		//printf("!*ERROR*!: Failed to change dir to TC_USER_LOG_DIR\n");
		return -1;
	}

	//get session_uid to make sure the log file name unique
	//POM_ask_session(&session_tag);
	//ITK__convert_tag_to_uid(session_tag, &session_uid);
	//get logFileName
	sprintf(logFileName, "%s_%s.txt", FunctionName, date_string);
	//printf("log file name: %s\n", logFileName);

	*fullname = (char*)MEM_alloc(sizeof(char) * 512);
	sprintf(*fullname, "%s\\%s", logFileDir, logFileName);

	//for(i = 0; _access((char *)logFileName, 4) == 0; i++)
	/*{
		memset(logFileName, 0, sizeof(logFileName));
		sprintf(logFileName, "%s_%s_%s_%d.log", FunctionName, session_uid, date_string, i);
	}
	printf("final log file name: %s\n", logFileName);*/

	//create log file
	*file = fopen(logFileName, "a");
	return ITK_ok;
	//CLEANUP:;
		//DOFREE(date_string);
		/*if(session_uid!=NULL){
			MEM_free(session_uid);
			session_uid=NULL;
		}*/
}


void WriteLog(logical debug, const char* format, ...)
{
	va_list arg;
	char tmp[MAX_PRINTLINE_LENGTH];
	memset(tmp, 0, sizeof(tmp));
	va_start(arg, format);
	vsprintf(tmp, format, arg);
	va_end(arg);
	printf("%s\n", tmp);
	TC_write_syslog("%s\n", tmp);
}

void WriteLog2(logical debug, const char* format, ...)
{
	va_list arg;
	char tmp[MAX_PRINTLINE_LENGTH];
	char date_string[MAX_PATH_LENGTH];
	time_t now;
	struct tm* p;

	//get the message
	memset(tmp, 0, sizeof(tmp));
	va_start(arg, format);
	vsprintf(tmp, format, arg);
	va_end(arg);
	//----------print to command window for trace--------//
	//printf("%s\n", tmp);
	printf("%s\n", tmp);
	//print message to log file
	if (!debug) {
		return;
	}
	if (logFile)
	{
		time(&now);
		//current_time(&status_now);
		p = localtime(&now);
		memset(date_string, 0, sizeof(date_string));
		sprintf(date_string, "%02d:%02d:%02d", p->tm_hour, p->tm_min, p->tm_sec);
		fprintf(logFile, "[%s] %s\n", date_string, tmp);
		fflush(logFile);
	}
	else
	{
		printf("*!Error!*: Log File Not Exist\n");
	}
}

void CloseLog(void)
{
	if (logFile)
	{
		fclose(logFile);
		logFile = NULL;
	}
}

void CreateLogFile(char* FunctionName, char* userId, char** fullname)
{
	int ifail = ITK_ok;
	//date_t status_now;
	//char* date_string = NULL;
	char date_string[MAX_PATH_LENGTH];
	char logFileDir[MAX_PATH_LENGTH];
	char logFileName[MAX_PATH_LENGTH];
	//char* session_uid = NULL;
	//tag_t session_tag = NULLTAG;

	time_t now;
	struct tm* p;

	time(&now);

	logFile = NULL;
	//current_time(&status_now);
	p = localtime(&now);

	memset(date_string, 0, sizeof(date_string));
	//sprintf(date_string,"%4d%02d%02d%02d%02d%02d",1900+p->tm_year,p->tm_mon+1 ,p->tm_mday ,p->tm_hour,p->tm_min ,p->tm_sec );
	sprintf(date_string, "%4d%02d%02d", 1900 + p->tm_year, p->tm_mon + 1, p->tm_mday);
	//if( DATE_date_to_string( status_now, "%Y%m%d%H%M%S", &date_string) != ITK_ok )
	//ifail = ITK_date_to_string (status_now, &date_string );
	//if (ifail)
	//{
	//	printf("!*ERROR*!: Failed to get current date time\n");
	//	goto CLEANUP;
	//}

	memset(logFileDir, 0, sizeof(logFileDir));
	memset(logFileName, 0, sizeof(logFileName));
	//get log dir
	sprintf(logFileDir, "%s", getenv("TEMP"));
	strcat(logFileDir, "\\tc_");
	strcat(logFileDir, userId);
	//printf("\n log file dir: %s\n", logFileDir);
	//try to change dir to TC_USER_LOG_DIR
	if (chdir(logFileDir) != ITK_ok)
	{
		//not set TC_USER_LOG_DIR
		//log in to default TC_LOG
		memset(logFileDir, 0, sizeof(logFileDir));
		sprintf(logFileDir, "%s", getenv("TC_LOG"));
		printf("\n TC_USER_LOG_DIR invalide, log file dir: %s\n", logFileDir);
		if (chdir(logFileDir) != ITK_ok)
		{
			//still can not change to log dir
			printf("!*ERROR*!: Failed to change dir to TC_USER_LOG_DIR\n");
			goto CLEANUP;
		}
	}

	//get session_uid to make sure the log file name unique
	//POM_ask_session(&session_tag);
	//ITK__convert_tag_to_uid(session_tag, &session_uid);
	//get logFileName
	sprintf(logFileName, "%s_%s_%s.log", FunctionName, userId, date_string);
	//printf("log file name: %s\n", logFileName);

	*fullname = (char*)MEM_alloc(sizeof(char) * 512);
	sprintf(*fullname, "%s\\%s", logFileDir, logFileName);

	//for(i = 0; _access((char *)logFileName, 4) == 0; i++)
	/*{
		memset(logFileName, 0, sizeof(logFileName));
		sprintf(logFileName, "%s_%s_%s_%d.log", FunctionName, session_uid, date_string, i);
	}
	printf("final log file name: %s\n", logFileName);*/

	//create log file
	logFile = fopen(logFileName, "a");

CLEANUP:;
	//DOFREE(date_string);
	/*if(session_uid!=NULL){
		MEM_free(session_uid);
		session_uid=NULL;
	}*/
}



void set_bypass(logical bypass)
{
	//AM__set_application_bypass(bypass);
	POM_AM__set_application_bypass(bypass);
}

bool isClass(tag_t class_id, char* className) {
	tag_t* pclass_ids = NULL;
	char* class_name = NULL;
	int pclass_count = 0, ifail = ITK_ok;
	ITKCALL(POM_name_of_class(class_id, &class_name));
	printf("class name = %s\n", class_name);
	bool isType = false;
	if (strcmp(class_name, className) == 0) {
		isType = true;
	}
	DOFREE(class_name);
	if (isType) {
		return true;
	}
	ITKCALL(ifail = POM_superclasses_of_class(class_id, &pclass_count, &pclass_ids));
	for (int i = 0; i < pclass_count; i++) {
		isType = isClass(pclass_ids[i], className);
		if (isType) {
			return true;
		}
	}
	return false;
}

bool isType(tag_t item, char* type) {
	tag_t class_id = NULLTAG, * pclass_ids = NULL;
	char* class_name = NULL;
	int pclass_count = 0, ifail = ITK_ok;

	ITKCALL(POM_class_of_instance(item, &class_id));
	return isClass(class_id, type);
}

void deleteFile(bool debug, char* path) {
	//?3y???t
	if (remove(path) == 0) {
		WriteLog(debug, "Delete File: %s", path);
	}
	else {
		WriteLog(debug, "Delete File failed: %s", path);
	}
}


int readError(bool debug, char* errFilePath, int errCode) {
	fstream _file;
	_file.open(errFilePath, ios::in);
	if (_file) {
		WriteLog(debug, "Find Error File: %s", errFilePath);
		ifstream fin(errFilePath);
		string s;
		while (getline(fin, s))
		{
			WriteLog(debug, s.c_str());
			EMH_store_error_s1(EMH_severity_error, errCode, s.c_str());
		}
		_file.close();
		return errCode;
	}
	return ITK_ok;
}

//??y?Y?
int import_dataset_file(tag_t dataset, const char* ref_name, char* ext, char* fullfilename, char* original_name)
{
	int ifail = ITK_ok;
	tag_t new_file_tag = NULLTAG;
	IMF_file_t file_descriptor = NULL;
	AOM_refresh(dataset, FALSE);
	char* new_file_name = NULL;
	char new_ds_name[WSO_name_size_c + 1] = "";
	char* filename = NULL;
	new_file_name = USER_new_file_name(new_ds_name, ref_name, ext, 0);
	filename = strrchr(fullfilename, '\\') + 1;
	if (filename == NULL)
		return ITK_ok;
	set_bypass(true);
	ITKCALL(ifail = IMF_import_file(fullfilename, new_file_name, SS_TEXT, &new_file_tag, &file_descriptor));
	if (ifail != ITK_ok) {
		ITKCALL(ifail = IMF_import_file(fullfilename, new_file_name, SS_BINARY, &new_file_tag, &file_descriptor));
	}
	ITKCALL(ifail = IMF_set_original_file_name2(new_file_tag, original_name));

	ITKCALL(ifail = IMF_close_file(file_descriptor));
	ITKCALL(ifail = AOM_save(new_file_tag));
	AOM_unlock(new_file_tag);
	ITKCALL(ifail = AOM_refresh(new_file_tag, FALSE));
	//?????y?
	set_bypass(true);
	ITKCALL(AOM_lock(dataset));
	ITKCALL(ifail = AE_remove_dataset_named_ref2(dataset, ref_name));
	ITKCALL(ifail = AOM_save(dataset));
	set_bypass(true);
	ITKCALL(ifail = AE_add_dataset_named_ref2(dataset, ref_name, AE_PART_OF, new_file_tag));
	AOM_save(dataset);
	AOM_unlock(dataset);
	set_bypass(false);
	//ITKCALL( AOM_refresh( dataset, FALSE ) );
	return ifail;
}

//??y?Y?
int import_dataset_file_binary(tag_t dataset, const char* ref_name, char* ext, char* fullfilename, char* original_name)
{
	int ifail = ITK_ok;
	tag_t new_file_tag = NULLTAG;
	IMF_file_t file_descriptor = NULL;
	AOM_refresh(dataset, FALSE);
	char* new_file_name = NULL;
	char new_ds_name[WSO_name_size_c + 1] = "";
	char* filename = NULL;
	new_file_name = USER_new_file_name(new_ds_name, ref_name, ext, 0);
	filename = strrchr(fullfilename, '\\') + 1;
	if (filename == NULL)
		return ITK_ok;
	set_bypass(true);
	ITKCALL(ifail = IMF_import_file(fullfilename, new_file_name, SS_BINARY, &new_file_tag, &file_descriptor));
	ITKCALL(ifail = IMF_set_original_file_name2(new_file_tag, original_name));

	ITKCALL(ifail = IMF_close_file(file_descriptor));
	ITKCALL(ifail = AOM_save(new_file_tag));
	AOM_unlock(new_file_tag);
	ITKCALL(ifail = AOM_refresh(new_file_tag, FALSE));
	//?????y?
	set_bypass(true);
	ITKCALL(AOM_lock(dataset));
	ITKCALL(ifail = AE_remove_dataset_named_ref2(dataset, ref_name));
	ITKCALL(ifail = AOM_save(dataset));
	set_bypass(true);
	ITKCALL(ifail = AE_add_dataset_named_ref2(dataset, ref_name, AE_PART_OF, new_file_tag));
	AOM_save(dataset);
	AOM_unlock(dataset);
	set_bypass(false);
	//ITKCALL( AOM_refresh( dataset, FALSE ) );
	return ifail;
}


void Split(string strArg, char spliter, vector<string>& ans)
{
	ans.clear();
	size_t index0 = 0;
	string one_arg;
	if (strArg.find_first_not_of(' ') == string::npos)
		strArg = "";
	while (strArg.size() > 0)
	{
		index0 = strArg.find_first_of(spliter);
		if (index0 != string::npos)
		{
			one_arg = strArg.substr(0, index0);
			strArg = strArg.substr(index0 + 1);
			ans.push_back(one_arg);
		}
		else
		{
			ans.push_back(strArg);
			break;
		}
	}
}

void Split(string strArg, string spliter, vector<string>& ans)
{
	ans.clear();
	size_t index0 = 0;
	string one_arg;
	if (strArg.find_first_not_of(' ') == string::npos)
		strArg = "";
	int len = spliter.size();
	while (strArg.size() > 0)
	{
		index0 = strArg.find(spliter);
		if (index0 != string::npos)
		{
			one_arg = strArg.substr(0, index0);
			strArg = strArg.substr(index0 + len);
			ans.push_back(one_arg);
			if (strArg.size() == 0) {
				ans.push_back(strArg);
			}
		}
		else
		{
			ans.push_back(strArg);
			break;
		}
	}
}

bool inArray(vector<string> types, string type) {
	int len = types.size();
	for (int i = 0; i < len; i++) {
		if (type == types[i]) {
			return true;
		}
	}
	return false;
}

int getIndexInArray(vector<string> types, string type) {
	int len = types.size();
	for (int i = 0; i < len; i++) {
		if (strcmp(types[i].c_str(), type.c_str()) == 0) {
			return i;
		}
	}
	return -1;
}

bool CheckType(string config, char* type, char spliter) {
	vector<string> types;
	Split(config, spliter, types);
	int len = types.size();
	for (int i = 0; i < len; i++) {
		if (strcmp(types[i].c_str(), type) == 0) {
			return true;
		}
	}
	return false;
}

int GetProcessTargets(bool debug, int att_cnt, tag_t* attachments, vector<tag_t>& targets, char* formType, char splitter) {
	char* object_name = NULL, * object_type = NULL;
	int ifail = ITK_ok;
	WriteLog(debug, "Get Targets of Process: %d", att_cnt);
	for (int i = 0; i < att_cnt; i++) {
		ITKCALL(ifail = WSOM_ask_name2(attachments[i], &object_name));
		ITKCALL(ifail = WSOM_ask_object_type2(attachments[i], &object_type));
		WriteLog(debug, "%d. Target [%s], type: %s", i + 1, object_name, object_type);
		//if (strcmp(object_type, TYPE_ITEM_PZJ.c_str()) == 0) {
		if (CheckType(formType, object_type, splitter)) {
			targets.push_back(attachments[i]);
		}
		DOFREE(object_name);
		DOFREE(object_type);
	}
	return ITK_ok;
}

int findUser(bool debug, string userStr, tag_t* user_tag) {
	int ind1 = userStr.find_first_of('(');
	int ind2 = userStr.find_first_of(')');
	WriteLog(debug, "Search User: %s", userStr.c_str());
	if (ind1 != string::npos && ind2 != string::npos && ind1 < ind2) {
		userStr = userStr.substr(ind1 + 1, ind2 - ind1 - 1);
		WriteLog(debug, ">> User id: %s", userStr.c_str());
	}
	int ifail = ITK_ok;
	ITKCALL(ifail = SA_find_user2(userStr.c_str(), user_tag));
	return ifail;
}

int GetBomLinePropString(bool debug, tag_t line, char* propName, int errCode, char** attr_val) {
	int attribute_id = 0, ifail = ITK_ok;
	ITKCALL(ifail = BOM_line_look_up_attribute(propName, &attribute_id));
	if (attribute_id == 0) {
		WriteLog(debug, "BOMLine property not exist: %s", propName);
		EMH_store_error_s2(EMH_severity_error, errCode, "BOMLine property not exist", propName);
		return errCode;
	}
	else {
		ITKCALL(ifail = BOM_line_ask_attribute_string(line, attribute_id, &*attr_val));
		return ifail;
	}
	return ITK_ok;
}

int GetStringProp(tag_t obj, char* propName, char** attr_val) {
	return AOM_ask_value_string(obj, propName, &*attr_val);
}

bool isRev(char* object_type) {
	if (((strstr(object_type, "Revision") != NULL) || (strstr(object_type, "revision") != NULL))
		&& (strstr(object_type, "Master") == NULL) && (strstr(object_type, "master") == NULL)
		&& (strstr(object_type, "BOM") == NULL) && (strstr(object_type, "bom") == NULL) && (strstr(object_type, "Bom") == NULL)) {
		return true;
	}
	return false;
}

int GetBomView(tag_t rev_tag, const char* viewtype, tag_t* bomView, tag_t* bomBVR, bool debug)
{
	WriteLog(debug, "Get BOM View: %s", viewtype);
	int ifail = ITK_ok, bvr_count = 0;
	tag_t* bvr_list = NULL, bom_view = NULLTAG, view_type = NULLTAG;
	*bomBVR = NULLTAG;
	*bomView = NULLTAG;
	ITKCALL(ITEM_rev_list_bom_view_revs(rev_tag, &bvr_count, &bvr_list));
	if (bvr_count > 0)
	{
		for (int i = 0; i < bvr_count; i++)
		{
			ITKCALL(PS_ask_bom_view_of_bvr(bvr_list[i], &bom_view));

			ITKCALL(PS_ask_bom_view_type(bom_view, &view_type));
			//ITKCALL( PS_find_view_type(bom_view, &view_type));
			char* view_type_name = NULL;
			ITKCALL(PS_ask_view_type_name(view_type, &view_type_name));
			WriteLog(debug, "Find View: %s", view_type_name);
			if (tc_strcmp(view_type_name, viewtype) == 0)
			{
				*bomBVR = bvr_list[i];
				*bomView = bom_view;
			}
			DOFREE(view_type_name);
		}
	}
	//else {
	//	WriteLog(debug, "??D??bvr?a???DD?");
	//	tag_t bv = NULLTAG, bvr = NULLTAG, item_tag = NULLTAG;
	//	int bvCnt = 0;
	//	tag_t* bvTags = NULL;


	//	ITKCALL(ifail = ITEM_ask_item_of_rev(rev_tag, &item_tag));


	//	tag_t tWindow = NULLTAG;
	//	ITKCALL(BOM_create_window(&tWindow));

	//	tag_t tTopLine = NULLTAG;
	//	ITKCALL(BOM_set_window_top_line(tWindow, item_tag, NULLTAG, NULLTAG, &tTopLine));

	//	//2??-BOM?
	//	ITKCALL(ifail=ITEM_list_bom_views(item_tag, &bvCnt, &bvTags));
	//	if (bvCnt > 0) {
	//		WriteLog(debug, "??????BOM?o%d", bvCnt);
	//		bv = bvTags[0];
	//	}
	//	ITKCALL(AOM_lock(item_tag));
	//	if (bv == NULLTAG) {
	//		ITKCALL(ifail=PS_create_bom_view(NULLTAG, "", "", item_tag, &bv));
	//		if (ifail != ITK_ok) {
	//			ITKCALL(AOM_unlock(item_tag));
	//			return ifail;
	//		}
	//		ITKCALL(AOM_save(bv));
	//	}
	//	ITKCALL(ifail=PS_create_bvr(bv, "", "", false, rev_tag, &bvr));
	//	if (ifail != ITK_ok) {
	//		ITKCALL(AOM_unlock(item_tag));
	//		return ifail;
	//	}
	//	ITKCALL(AOM_save(bvr));
	//	ITKCALL(AOM_save(bv));
	//	ITKCALL(AOM_save(item_tag));

	//	tag_t tChildLine = NULLTAG;

	//	ITKCALL(BOM_save_window(tWindow));
	//	ITKCALL(BOM_close_window(tWindow));

	//	ITKCALL(AOM_unlock(item_tag));
	//	*bomBVR = bvr;
	//	*bomView = bv;
	//	WriteLog(debug, "bvrD??3");
	//	DOFREE(bvTags);

	//}
	DOFREE(bvr_list);
	return ifail;
}

bool propExist(bool debug, tag_t obj, const char* propName) {
	tag_t clTag = NULLTAG, * superClass = NULL;
	char* clName = NULL;
	int ifail = ITK_ok, cnt = 0;
	logical exists = false;
	ITKCALL(ifail = POM_class_of_instance(obj, &clTag));
	if (ifail != ITK_ok) { return false; }
	ITKCALL(ifail = POM_name_of_class(clTag, &clName));
	if (ifail != ITK_ok) { return false; }
	WriteLog(debug, ">> [%s] Check Property: %s", clName, propName);
	ITKCALL(ifail = POM_attr_exists(propName, clName, &exists));
	if (ifail != ITK_ok) { return false; }
	DOFREE(clName);
	if (exists) {
		//WriteLog(debug,"?D???");
		return exists;
	}
	ITKCALL(ifail = POM_superclasses_of_class(clTag, &cnt, &superClass));
	for (int i = 0; i < cnt; i++) {
		ITKCALL(ifail = POM_name_of_class(superClass[i], &clName));
		if (ifail != ITK_ok) { return false; }
		WriteLog(debug, ">> [%s] Check Property: %s", clName, propName);
		ITKCALL(ifail = POM_attr_exists(propName, clName, &exists));
		DOFREE(clName);
		if (exists) {
			//WriteLog(debug, "?D???");
			return exists;
		}
	}
	WriteLog(debug, "Property not exist");
	return exists;
}

string trim(const string& str)
{
	size_t first = str.find_first_not_of(' ');
	if (string::npos == first)
	{
		return str;
	}
	size_t last = str.find_last_not_of(' ');
	string res= str.substr(first, (last - first + 1));
	last = res.find("\n");
	if (last == res.size() - 1) {
		res = res.substr(0, res.size() - 1);
	}
	last = res.find("\r");
	if (last == res.size() - 1) {
		res = res.substr(0, res.size() - 1);
	}
	return res;
}

char* U2G(const char* utf8)
{
	int len = MultiByteToWideChar(CP_UTF8, 0, utf8, -1, NULL, 0);
	wchar_t* wstr = new wchar_t[len + 1];
	memset(wstr, 0, len + 1);
	MultiByteToWideChar(CP_UTF8, 0, utf8, -1, wstr, len);
	len = WideCharToMultiByte(CP_ACP, 0, wstr, -1, NULL, 0, NULL, NULL);
	char* str = new char[len + 1];
	memset(str, 0, len + 1);
	WideCharToMultiByte(CP_ACP, 0, wstr, -1, str, len, NULL, NULL);
	if (wstr) delete[] wstr;
	return str;
}



char* G2U(const char* gb2312)
{
	int len = MultiByteToWideChar(CP_ACP, 0, gb2312, -1, NULL, 0);
	wchar_t* wstr = new wchar_t[len + 1];
	memset(wstr, 0, len + 1);
	MultiByteToWideChar(CP_ACP, 0, gb2312, -1, wstr, len);
	len = WideCharToMultiByte(CP_UTF8, 0, wstr, -1, NULL, 0, NULL, NULL);
	char* str = new char[len + 1];
	memset(str, 0, len + 1);
	WideCharToMultiByte(CP_UTF8, 0, wstr, -1, str, len, NULL, NULL);
	if (wstr) delete[] wstr;
	return str;
}

int getPrefStrings(const char* preference, TC_preference_search_scope_t scope, vector<string>& pref_vec)
{
	int ifail = ITK_ok, i = 0, j = 0, k = 0, num = 0;
	char** values;
	TC_preference_search_scope_t old_scope;
	//ITKCALL(ifail = PREF_ask_search_scope(&old_scope));
	//ITKCALL(ifail = PREF_set_search_scope(scope));
	//ITKCALL(ifail = PREF_ask_char_values(preference, &num, &values));
	ITKCALL(ifail = PREF_ask_char_values_at_location(preference, scope, &num, &values));
	if (ifail != ITK_ok) {
		return ifail;
	}
	for (i = 0; i < num; i++)
	{
		pref_vec.push_back(values[i]);
	}
	DOFREE(values);
	//ITKCALL(ifail = PREF_set_search_scope(old_scope));
	return ifail;
}

int getPrefStrings2(const char* preference, TC_preference_search_scope_t scope, char splitter, vector<string>& pref_vec)
{
	int ifail = ITK_ok, i = 0, j = 0, k = 0, num = 0;
	char** values;
	TC_preference_search_scope_t old_scope;
	//ITKCALL(ifail = PREF_ask_search_scope(&old_scope));
	//ITKCALL(ifail = PREF_set_search_scope(scope));
	//ITKCALL(ifail = PREF_ask_char_values(preference, &num, &values));
	ITKCALL(ifail = PREF_ask_char_values_at_location(preference, scope, &num, &values));
	if (ifail != ITK_ok) {
		return ifail;
	}
	for (i = 0; i < num; i++)
	{
		vector<string> split;
		Split(values[i], splitter, split);
		int size = split.size();
		for (j = 0; j < size; j++) {
			pref_vec.push_back(split[j]);
		}
		/*for each (string val in split) {
			pref_vec.push_back(val);
		}*/
	}
	DOFREE(values);
	//ITKCALL(ifail = PREF_set_search_scope(old_scope));
	return ifail;
}

//?3?y?Y????t 
int export_dataset_file(bool debug, tag_t dataset, const char* ref_name, const char* ext, char** filename, char** original_name)
{
	int ifail = ITK_ok;
	tag_t ref_object = NULLTAG,
		datasettype = NULLTAG,
		new_ds = NULLTAG,
		tool = NULLTAG,
		folder_tag = NULLTAG,
		spec_dataset_rev = NULLTAG;
	AE_reference_type_t reference_type;
	tag_t new_file_tag = NULLTAG;
	IMF_file_t file_descriptor;
	char* target_ds_name = NULL;
	char* new_file_name;
	WSOM_ask_name2(dataset, &target_ds_name);
	WriteLog(debug, "Download file from dataset %s", target_ds_name);
	DOFREE(target_ds_name);
	*filename = (char*)MEM_alloc(sizeof(char) * 512);
	*original_name = (char*)MEM_alloc(sizeof(char) * 512);
	strcpy(*filename, "");
	AE_ask_dataset_latest_rev(dataset, &spec_dataset_rev);
	AE_ask_dataset_named_ref2(dataset, ref_name, &reference_type, &ref_object);
	if (ref_object == NULLTAG)
	{
		WriteLog(debug, "File ref not exist");
		return 1;
	}
	if (reference_type == AE_PART_OF)
	{
		char* pathname2 = NULL;
		IMF_ask_file_pathname2(ref_object, SS_WNT_MACHINE, &pathname2);
		DOFREE(pathname2);
		char* origin_file_name2 = NULL;
		IMF_ask_original_file_name2(ref_object, &origin_file_name2);
		strcpy(*original_name, origin_file_name2);
		DOFREE(origin_file_name2);
		char new_ds_name[WSO_name_size_c + 1] = "";
		char* new_file_name = USER_new_file_name(new_ds_name, ref_name, ext, 0);
		char* temp_dir = getenv("TEMP");
		char temp_file[SS_MAXPATHLEN] = "";
		strcpy(temp_file, temp_dir);
		//strcat(temp_file, "\\tc_");
		//strcat(temp_file, userId);
		strcat(temp_file, "\\");
		strcat(temp_file, new_file_name);
		WriteLog(debug, "Temp path: %s", temp_file);
		if ((_access(temp_file, 0)) != -1) {
			if (!remove(temp_file)) {
				remove(temp_file);
			}
		}
		IMF_export_file(ref_object, temp_file);
		strcpy(*filename, temp_file);
		return ITK_ok;
	}
	return -1;
}